FROM rust:1.75 as builder


WORKDIR /usr/src/rust_microservice

COPY ./Cargo.toml ./Cargo.toml
COPY ./Cargo.lock ./Cargo.lock

RUN mkdir src/ && \
    echo "fn main() {println!(\"if you see this, the build broke\")}" > src/main.rs && \
    cargo build --release && \
    rm -f target/release/deps/rust_microservice*

COPY ./src ./src

# Build for release
RUN cargo build --release

FROM debian:bookworm-slim
WORKDIR /usr/local/bin

COPY --from=builder /usr/src/rust_microservice/target/release/rust_microservice .

# Set permissions to execute the binary
RUN chmod +x ./rust_microservice

# Run the binary
CMD ["./rust_microservice"]
